/* $Id: dtime.c,v 1.3 2000/09/21 04:53:22 alinden Exp $ */

/*
*  File             : dtime.c
*  Written by       : alinden@gmx.de
*  Portability      : Should be POSIX compliant
*  Copyright        : GPL
*  DESCRIPTION:     : Prints the uptime information maintained by crond
*                   : (path to file defined in TIMEFILE) to stdout. 
*/

#include "crond.h"
#include "conf.h"

void prtimer(char *info, long seconds)  /* Print seconds in d,h */ 
{
	int days=seconds/(60*60*24);

	if(days < 0)
		days = 0;

	printf("%s%dd %dh\n", info, days, (int)((seconds/(60*60))-days*24));
}

int main(int argc, char *argv[])
{
	FILE *timefile;
	long starttime,uptime;


	if(argc > 1 && strcmp(argv[1], "--version") == 0)
	{
		puts(VERSION);
		exit(0);
	}

	if ( (timefile = fopen(TIMEFILE, "r")) == NULL)
	{
		perror("Can't open uptime");
		exit(1);
	}
	if ( fscanf(timefile, "%ld\n%ld", &starttime, &uptime) < 2)
	{
		fputs("Can't read uptime\n", stderr);
		exit(1);
	}
	printf("Counting since %s", ctime(&starttime));
	prtimer("Total uptime  : ", uptime);
	prtimer("Total downtime: ", (long)time(NULL)-starttime-uptime);
	exit(0);
}	  
